<?php

// INCLUDES
define('PHPWG_ROOT_PATH','../../');
include_once(PHPWG_ROOT_PATH.'include/common.inc.php');

// If function mime_content_type is not available, our best
// shop is to hope that we run a *nix system
if (!function_exists('mime_content_type')) {
   function mime_content_type ($f) {
       return trim(shell_exec('file -bi '.escapeshellarg($f)));
   }
}


// CHECKING PARAMETERS
if (!is_numeric($_GET['image_id']))
{
  die('Hacking attempt on "image_id" GET parameter');
}

if (substr(PHPWG_VERSION, 2, 1) >= 6) {
  // Check Access and exit when user status is not ok
  check_status(ACCESS_GUEST);
}

$query = '
SELECT i.path, i.tn_ext, ic.category_id, c.status
  FROM '.IMAGES_TABLE.' AS i
    INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
    INNER JOIN '.CATEGORIES_TABLE.' AS c ON c.id = ic.category_id
    WHERE i.id = '.$_GET['image_id'].'
  ';

$result = pwg_query( $query );

if ($row = mysql_fetch_array($result)) {

  // Authorization checking
  if ( isset( $row['category_id'] ) and is_numeric( $row['category_id'] ) )
  {
    check_restrictions( $row['category_id'] );
  }

  // Do we want the thumbnail of the picture ?
  if ($_GET['thumb'] == 1)
    $row['path'] = substr_replace(get_filename_wo_extension($row['path']),
                          '/thumbnail/'.$conf['prefix_thumbnail'],
                          strrpos($row['path'],'/'),
                          1).'.'.$row['tn_ext'];

  // Do we want the HD version of the picture ?
  if ($_GET['highdef'] == 1)
    $row['path'] = dirname($row['path']).'/pwg_high/'.basename($row['path']);

  // Is this image on a remote server ?
  if (substr($row['path'], 0, 7) == 'http://') {
    header('Location: '.$row['path']);
    exit;
  }

  $row['path'] = PHPWG_ROOT_PATH.$row['path'];

  // CACHE VERIFICATION
  // If the client has a version in his cache, we check if it was modified 
  // since he made a copy. If not, we let him use his cache.
  if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) >= filemtime($row['path'])) {
    header('HTTP/1.x 304 Not Modified');
    exit;
  }

  header('Content-type: '.mime_content_type($row['path']));
  header('Last-Modified: '.date('r', filemtime($row['path'])));
  readfile($row['path']);
}

?>
